From 6d99f2a79f7c92d649da41122204939584d419c2 Mon Sep 17 00:00:00 2001
From: Jehan-Guillaume de Rorthais <jgdr@dalibo.com>
Date: Thu, 23 Jul 2020 10:56:17 +0200
Subject: [PATCH] Shutdown Gather Merge workers when exhausted

Release resources as soon as we can, when all workers are exhausted.

Author: Jehan-Guillaue de Rorthais <jgdr@dalibo.com>
---
 src/backend/executor/nodeGatherMerge.c | 1 +
 1 file changed, 1 insertion(+)

diff --git a/src/backend/executor/nodeGatherMerge.c b/src/backend/executor/nodeGatherMerge.c
index 47129344f3..9a237e7c03 100644
--- a/src/backend/executor/nodeGatherMerge.c
+++ b/src/backend/executor/nodeGatherMerge.c
@@ -580,6 +580,7 @@ gather_merge_getnext(GatherMergeState *gm_state)
 	{
 		/* All the queues are exhausted, and so is the heap */
 		gather_merge_clear_tuples(gm_state);
+		ExecShutdownGatherMergeWorkers(gm_state);
 		return NULL;
 	}
 	else
-- 
2.20.1

